//---------------------------------------------------------------------------
#ifndef TMainFormH
#define TMainFormH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\DBTables.hpp>
#include <vcl\DB.hpp>
#include <vcl\DBCtrls.hpp>
#include <vcl\Mask.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\Dialogs.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\ComCtrls.hpp>
//---------------------------------------------------------------------------
#ifdef Dbg
    #undef Dbg
#endif
#define Dbg( STR )          {                                                                               \
                            DebuggingForm->ListBox->Items->Add( (STR) );                                    \
                            }
//---------------------------------------------------------------------------
#ifdef Msg
    #undef Msg
#endif
#define Msg( STR )          {                                                                               \
                            DebugLabel->Caption = (STR);                                                    \
                            DebugLabel->Refresh();                                                          \
                            }
//---------------------------------------------------------------------------
#ifdef ERROR
    #undef ERROR
#endif
#define ERROR( STR )        {                                                                               \
                            DebuggingForm->ListBox->Items->Add( "Error:");                                  \
                            DebuggingForm->ListBox->Items->Add( (STR) );                                    \
                            DebuggingForm->ListBox->Items->Add( "Error Line: " + ImportString );            \
                            DebuggingForm->Show();                                                          \
                            DebugLabel->Caption = "AN ERROR OCCURRED. Check debug output for details...";   \
                            DebugLabel->Refresh();                                                          \
                            return;                                                                         \
                            }
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
    TTable *Structures_Table;
    TDatabase *DirectX_To_BCB;
    TDataSource *Structures_DataSource;
    TOpenDialog *ImportFileDialog;
    TQuery *TempQuery;
    TTable *StructureMembers_Table;
    TTable *StructureMemberFlags_Table;
    TDataSource *StructureMembers_DataSource;
    TDataSource *StructureMemberFlags_DataSource;
    TPageControl *DirectXFoundationClassPages;
    TTabSheet *TabSheet6;
    TTabSheet *TabSheet7;
    TPageControl *DirectDrawPages;
    TTabSheet *TabSheet1;
    TTabSheet *TabSheet4;
    TTabSheet *TabSheet5;
    TTabSheet *TabSheet2;
    TTabSheet *TabSheet3;
    TTabSheet *TabSheet8;
    TTabSheet *TabSheet9;
    TTabSheet *TabSheet10;
    TTabSheet *TabSheet12;
    TTabSheet *TabSheet13;
    TTabSheet *TabSheet14;
    TTable *FoundationClass_Table;
    TPageControl *DirectDrawEditPages;
    TTabSheet *DirectX_TabSheet;
    TLabel *Label2;
    TLabel *Label3;
    TLabel *Label4;
    TLabel *Label8;
    TLabel *Label10;
    TLabel *Label11;
    TLabel *Label12;
    TLabel *Label13;
    TLabel *Label21;
    TLabel *Label22;
    TLabel *Label23;
    TComboBox *DirectX_ComboBox;
    TDBEdit *DirectX_StructureName_Edit;
    TDBMemo *DirectX_StructureDesc_Memo;
    TDBMemo *DirectX_StructureMember_Memo;
    TDBEdit *DirectX_StructureMember_Edit;
    TComboBox *DirectX_StructureMember_ComboBox;
    TComboBox *DirectX_MemberFlags_ComboBox;
    TDBMemo *DirectX_MemberFlagsDesc_Memo;
    TBitBtn *BitBtn6;
    TBitBtn *BitBtn7;
    TBitBtn *BitBtn10;
    TBitBtn *BitBtn5;
    TDBRadioGroup *DBRadioGroup4;
    TDBRadioGroup *DBRadioGroup5;
    TDBRadioGroup *DBRadioGroup6;
    TTabSheet *BCB_TabSheet;
    TLabel *Label7;
    TLabel *Label6;
    TLabel *Label5;
    TLabel *Label9;
    TLabel *Label14;
    TLabel *Label15;
    TLabel *Label16;
    TLabel *Label17;
    TLabel *Label18;
    TLabel *Label19;
    TLabel *Label20;
    TComboBox *BCB_ComboBox;
    TDBEdit *BCB_ObjectName_Edit;
    TDBMemo *BCB_ObjectDescription_Memo;
    TComboBox *BCB_ObjectProperty_ComboBox;
    TDBEdit *BCB_PropertyName_Edit;
    TDBMemo *BCB_PropertyDescription_Memo;
    TComboBox *BCB_PropertyFlags_ComboBox;
    TDBMemo *BCB_PropertyFlagsDescript_Memo;
    TBitBtn *BitBtn11;
    TBitBtn *BitBtn12;
    TBitBtn *BitBtn14;
    TBitBtn *BitBtn15;
    TDBRadioGroup *BCB_ObjectStatus;
    TDBRadioGroup *DBRadioGroup2;
    TDBRadioGroup *DBRadioGroup3;
    TLabel *DebugLabel;
    TBitBtn *BitBtn4;
    TBitBtn *BitBtn3;
    TBitBtn *BitBtn8;
    TBitBtn *BitBtn9;
    TLabel *Label24;
    TLabel *LinkedLabel;
    TPageControl *PageControl1;
    TTabSheet *TabSheet11;
    TLabel *Label1;
    TLabel *Label25;
    TLabel *Label26;
    TLabel *Label27;
    TLabel *Label28;
    TLabel *Label29;
    TLabel *Label30;
    TLabel *Label31;
    TLabel *Label32;
    TLabel *Label33;
    TLabel *Label34;
    TLabel *Label35;
    TComboBox *ComboBox1;
    TDBEdit *DBEdit1;
    TDBMemo *DBMemo1;
    TDBMemo *DBMemo2;
    TDBEdit *DBEdit2;
    TComboBox *ComboBox2;
    TComboBox *ComboBox3;
    TDBMemo *DBMemo3;
    TBitBtn *BitBtn1;
    TBitBtn *BitBtn2;
    TBitBtn *BitBtn13;
    TBitBtn *BitBtn16;
    TDBRadioGroup *DBRadioGroup1;
    TDBRadioGroup *DBRadioGroup7;
    TDBRadioGroup *DBRadioGroup8;
    TTabSheet *TabSheet15;
    TLabel *Label36;
    TLabel *Label37;
    TLabel *Label38;
    TLabel *Label39;
    TLabel *Label40;
    TLabel *Label41;
    TLabel *Label42;
    TLabel *Label43;
    TLabel *Label44;
    TLabel *Label45;
    TLabel *Label46;
    TComboBox *ComboBox4;
    TDBEdit *DBEdit3;
    TDBMemo *DBMemo4;
    TComboBox *ComboBox5;
    TDBEdit *DBEdit4;
    TDBMemo *DBMemo5;
    TComboBox *ComboBox6;
    TDBMemo *DBMemo6;
    TBitBtn *BitBtn17;
    TBitBtn *BitBtn18;
    TBitBtn *BitBtn19;
    TBitBtn *BitBtn20;
    TDBRadioGroup *DBRadioGroup9;
    TDBRadioGroup *DBRadioGroup10;
    TDBRadioGroup *DBRadioGroup11;
    void __fastcall FormActivate(TObject *Sender);
    void __fastcall FormDeactivate(TObject *Sender);
    void __fastcall FormCreate(TObject *Sender);
    
    
    
    void __fastcall BitBtn3Click(TObject *Sender);
    void __fastcall BCB_ObjectName_EditExit(TObject *Sender);
    void __fastcall BCB_PropertyName_EditExit(TObject *Sender);
    void __fastcall BCB_PropertyFlagsDescript_MemoExit(TObject *Sender);
    void __fastcall DBRadioGroup1Exit(TObject *Sender);
    void __fastcall BitBtn4Click(TObject *Sender);
    void __fastcall Label7Click(TObject *Sender);
    void __fastcall Label6Click(TObject *Sender);
    void __fastcall Label5Click(TObject *Sender);
    void __fastcall Label9Click(TObject *Sender);
    void __fastcall Label14Click(TObject *Sender);
    void __fastcall Label15Click(TObject *Sender);
    void __fastcall Label16Click(TObject *Sender);
    void __fastcall Label17Click(TObject *Sender);
    void __fastcall BitBtn7Click(TObject *Sender);
    
    void __fastcall DirectXFoundationClassPagesChange(TObject *Sender);
    void __fastcall DirectX_ComboBoxChange(TObject *Sender);
    void __fastcall DirectX_StructureMember_ComboBoxChange(TObject *Sender);
    
    void __fastcall DirectX_MemberFlags_ComboBoxChange(TObject *Sender);
    
    
    
    
    
    
    
    
    
    void __fastcall BitBtn8Click(TObject *Sender);
    
    void __fastcall BitBtn9Click(TObject *Sender);
    
    void __fastcall BitBtn6Click(TObject *Sender);
    void __fastcall BitBtn10Click(TObject *Sender);
    void __fastcall BitBtn5Click(TObject *Sender);
protected:
private:	// User declarations
    int     fFoundation_Class_Index;
    int     fStructure_Index;
    int     fMember_Index;
    bool    fLinked;

    // import bits & pieces
    TStringList*    fImportStrings;
    int             fImportRow;

    __property  int                 ImportRow = {read=fImportRow,write=FSetImportRow};
    __property  TStringList*        ImportStrings = {read=fImportStrings,write=fImportStrings};
    __property  AnsiString          ImportString = {read=FGetImportString};

    void        __fastcall  ImportFile( AnsiString pFileName );

    void        __fastcall  FSetImportRow( int row );
    AnsiString  __fastcall  FGetImportString();

    // general import rules
    AnsiString  __fastcall  EncodeValue( AnsiString code, int value );
    int         __fastcall  DecodeValue( AnsiString code, AnsiString encoded_string, AnsiString* decoded_string );
    AnsiString  __fastcall  RemoveHungarianNotation( AnsiString hungarian_string );

    bool    __fastcall  IsKeyword( AnsiString string, AnsiString keyword ) { return (string==keyword); }
    bool    __fastcall  IsValidStructureName( AnsiString string ) { return (string.Pos(" ")==0); }
    bool    __fastcall  IsStartOfStruct( AnsiString string ) { return (string.Pos("struct")!=0); }
    bool    __fastcall  IsEndOfStruct( AnsiString string ) { return (string.Pos("} ")!=0); }
    bool    __fastcall  IsStartOfUnion( AnsiString string ) { return (string.Pos("union")!=0); }
    bool    __fastcall  IsEndOfUnion( AnsiString string ) { return (string.Pos("};")!=0); }
    bool    __fastcall  ContainsStartBracket( AnsiString string ) { return (string.Pos("{")!=0); }
    bool    __fastcall  IsFlag( AnsiString string );
    bool    __fastcall  IsThisAndThat( TStringList* known_items, AnsiString string, AnsiString* this_string, AnsiString* that_string );
    bool    __fastcall  IsThisAndThatAndSomethingElse( TStringList* known_items, AnsiString string, TStringList* result_strings );

    // import structure bits & pieces

    TStringList*    fStructureNames;
    TStringList*    fStructureDescriptions;
    TStringList*    fMemberNames;
    TStringList*    fMemberTypes;
    TStringList*    fMemberDescriptions;
    TStringList*    fFlagNames;
    TStringList*    fFlagDescriptions;

    void        __fastcall  ImportStructures( AnsiString pFileName );
    bool        __fastcall  IsStructureName( TStringList* structure_name_strings, AnsiString structure_name );
    bool        __fastcall  IsMemberName( TStringList* member_name_strings, AnsiString member_name );

    // import interface bits & pieces  BRIAN STARTS HERE
    bool    	__fastcall  IsValidInterfaceName( AnsiString string ) { return (string.Pos(" ")==0); }
    bool    	__fastcall  IsSingleToken( AnsiString string ) { return (string.Pos(" ")==0); }

	bool    	__fastcall  IsInterfaceName( TStringList* Interface_name_strings, AnsiString Interface_name );
   	bool    	__fastcall  IsPropertyName( TStringList* property_name_strings, AnsiString property_name );

    void    	__fastcall  ImportInterfaces( AnsiString pFileName );

   	TStringList*    fInterfaceNames;
   	TStringList*    fInterfaceDescriptions;
   	TStringList*    fPropertyNames;
   	TStringList*    fPropertyDescriptions;
   	TStringList*    fPropertyReturnTypes;
    TStringList*	fPropertyReturnValues;
   	TStringList*    fParameterTypes;
   	TStringList*    fParameterNames;
   	TStringList*    fParameterModifiers;  //can be "*" or "FAR *"
   	TStringList*    fParameterDescriptions;
   	// BRIAN ENDS HERE

    // other user-interface bits & pieces
    void    __fastcall  BuildComboSelections();
    void    __fastcall  BuildStructureSelections();
    void    __fastcall  BuildMemberSelections();
    void    __fastcall  BuildFlagSelections();

public:		// User declarations
    __fastcall TMainForm(TComponent* Owner);
    virtual __fastcall ~TMainForm();
};
//---------------------------------------------------------------------------
extern TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif



